- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::PDSystemSolver Class Reference

Pure Primal Dual System Solver Base Class. More...

`#include <IpPDSystemSolver.hpp>`

Inheritance diagram for Ipopt::PDSystemSolver:

[legend]
Collaboration diagram for Ipopt::PDSystemSolver:

[legend]
List of all members.

## Public Member Functions
virtual bool | InitializeImpl (const OptionsList &options, const std::string &prefix)=0
| overloaded from AlgorithmStrategyObject
virtual bool | Solve (Number alpha, Number beta, const IteratesVector &rhs, IteratesVector &res, bool allow_inexact=false, bool improve_solution=false)=0
| Solve the primal dual system, given one right hand side.
/Destructor
| PDSystemSolver ()
| Default Constructor.
virtual | ~PDSystemSolver ()
| Default destructor.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
PDSystemSolver & | operator= (const PDSystemSolver &)
| Overloaded Equals Operator.

## Detailed Description

Pure Primal Dual System Solver Base Class.

This is the base class for all derived Primal-Dual System Solver Types.

Here, we understand the primal-dual system as the following linear system:

Here, , , , . The results returned to the caller is .

The solution of this linear system (in order to compute the search direction of the algorthim) usually requires a considerable amount of computation time. Therefore, it is important to tailor the solution of this system to the characteristics of the problem. The purpose of this base class is to provide a generic interface to the algorithm that it can use whenever it requires a solution of the above system. Particular implementation can then be written to provide the methods defined here.

It is implicitly assumed here, that the upper left 2 by 2 block is possibly modified (implicitly or explicitly) so that its projection onto the null space of the overall constraint Jacobian is positive definite. This is necessary to guarantee certain descent properties of the resulting search direction. For example, in the full space implementation, a multiple of the identity might be added to the upper left 2 by 2 block.

Note that the Solve method might be called several times for different right hand sides, but with identical data. Therefore, if possible, an implemetation of PDSystem should check whether the incoming data has changed, and not redo factorization etc. unless necessary.

Definition at line 76 of file IpPDSystemSolver.hpp.

## Constructor & Destructor Documentation

Ipopt::PDSystemSolver::PDSystemSolver | ( |  | ) | `[inline]`

Default Constructor.

Definition at line 82 of file IpPDSystemSolver.hpp.

virtual Ipopt::PDSystemSolver::~PDSystemSolver | ( |  | ) | `[inline, virtual]`

Default destructor.

Definition at line 86 of file IpPDSystemSolver.hpp.

## Member Function Documentation

virtual bool Ipopt::PDSystemSolver::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[pure virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::AlgorithmStrategyObject.

Implemented in Ipopt::PDFullSpaceSolver.

virtual bool Ipopt::PDSystemSolver::Solve | ( | Number | alpha,
|  | Number | beta,
|  | const IteratesVector & | rhs,
|  | IteratesVector & | res,
|  | bool | allow_inexact = `false`,
|  | bool | improve_solution = `false` |
| ) |  |  | `[pure virtual]`

Solve the primal dual system, given one right hand side.

If the flag allow_inexact is set to true, it is not necessary to solve the system to best accuracy; for example, we don't want iterative refinement during the computation of the second order correction. On the other hand, if improve_solution is true, the solution given in res should be improved (here beta has to be zero, and res is assume to be the solution for the system using rhs, without the factor alpha...). THe return value is false, if a solution could not be computed (for example, when the Hessian regularization parameter becomes too large.)

Implemented in Ipopt::PDFullSpaceSolver.

PDSystemSolver& Ipopt::PDSystemSolver::operator= | ( | const PDSystemSolver & |  | ) | `[private]`

Overloaded Equals Operator.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/Algorithm/IpPDSystemSolver.hpp